#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './streamsettings.ui'
**
** Created: Sat Aug 2 19:58:17 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "streamsettings.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <knuminput.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "settingswidget.h"
#include "knuminput.h"
#include "./streamsettings.ui.h"

/*
 *  Constructs a StreamSettings which is a child of 'parent', with the
 *  name 'name'.' 
 */
StreamSettings::StreamSettings( QWidget* parent,  const char* name )
    : SettingsWidget( parent, name )
{
    if ( !name )
	setName( "StreamSettings" );
    StreamSettingsLayout = new QGridLayout( this, 1, 1, 11, 6, "StreamSettingsLayout"); 
    spacer3 = new QSpacerItem( 20, 30, QSizePolicy::Minimum, QSizePolicy::Expanding );
    StreamSettingsLayout->addItem( spacer3, 1, 0 );

    tagsGroupBox = new QGroupBox( this, "tagsGroupBox" );
    tagsGroupBox->setColumnLayout(0, Qt::Vertical );
    tagsGroupBox->layout()->setSpacing( 6 );
    tagsGroupBox->layout()->setMargin( 11 );
    tagsGroupBoxLayout = new QGridLayout( tagsGroupBox->layout() );
    tagsGroupBoxLayout->setAlignment( Qt::AlignTop );

    ripDurationSpinBox = new KIntSpinBox( tagsGroupBox, "ripDurationSpinBox" );
    ripDurationSpinBox->setMaxValue( 2147483647 );
    ripDurationSpinBox->setMinValue( 1 );
    ripDurationSpinBox->setValue( 600 );

    tagsGroupBoxLayout->addWidget( ripDurationSpinBox, 0, 2 );

    ripDurationLabel = new QLabel( tagsGroupBox, "ripDurationLabel" );

    tagsGroupBoxLayout->addWidget( ripDurationLabel, 0, 0 );

    ripDurationLabel2 = new QLabel( tagsGroupBox, "ripDurationLabel2" );

    tagsGroupBoxLayout->addWidget( ripDurationLabel2, 0, 1 );

    ripIncompleteCheckBox = new QCheckBox( tagsGroupBox, "ripIncompleteCheckBox" );

    tagsGroupBoxLayout->addMultiCellWidget( ripIncompleteCheckBox, 1, 1, 0, 2 );

    cleanUpRippedStreamsButton = new QPushButton( tagsGroupBox, "cleanUpRippedStreamsButton" );

    tagsGroupBoxLayout->addMultiCellWidget( cleanUpRippedStreamsButton, 2, 2, 0, 2 );

    StreamSettingsLayout->addWidget( tagsGroupBox, 0, 0 );
    languageChange();
    resize( QSize(395, 135).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( cleanUpRippedStreamsButton, SIGNAL( clicked() ), this, SLOT( cleanUpRippedStreams() ) );
    connect( ripDurationSpinBox, SIGNAL( valueChanged(int) ), this, SLOT( emitSettingsChanged() ) );
    connect( ripIncompleteCheckBox, SIGNAL( toggled(bool) ), this, SLOT( emitSettingsChanged() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
StreamSettings::~StreamSettings()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void StreamSettings::languageChange()
{
    setCaption( tr2i18n( "Streams Settings" ) );
    tagsGroupBox->setTitle( tr2i18n( "Streams Rip" ) );
    ripDurationLabel->setText( tr2i18n( "Rip duration" ) );
    QWhatsThis::add( ripDurationLabel, tr2i18n( "<qt>Rip duration (applies to every stream individually).<qt>" ) );
    ripDurationLabel2->setText( tr2i18n( "<p align=\"right\">secs</p>" ) );
    ripIncompleteCheckBox->setText( tr2i18n( "I&nclude incomplete files" ) );
    ripIncompleteCheckBox->setAccel( QKeySequence( tr2i18n( "Alt+N" ) ) );
    QToolTip::add( ripIncompleteCheckBox, tr2i18n( "<qt>Process files marked as incomplete by streamripper.<qt>" ) );
    QWhatsThis::add( ripIncompleteCheckBox, QString::null );
    cleanUpRippedStreamsButton->setText( tr2i18n( "Cle&an up temporary files" ) );
    cleanUpRippedStreamsButton->setAccel( QKeySequence( tr2i18n( "Alt+A" ) ) );
    QToolTip::add( cleanUpRippedStreamsButton, tr2i18n( "<qt><i>All</i> ripped streams are kept under directory '/tmp/transkode-$USER'.<br/>Press this button to erase it's contents.</qt>" ) );
}

#include "streamsettings.moc"
